import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkCoachOrder, ThinkCoachOrderParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询教练组订单
 */
export async function pageThinkCoachOrder(params: ThinkCoachOrderParam) {
  const res = await request.get<ApiResult<PageResult<ThinkCoachOrder>>>(
    THINK_API_URL + '/think/think-coach-order/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询教练组订单列表
 */
export async function listThinkCoachOrder(params?: ThinkCoachOrderParam) {
  const res = await request.get<ApiResult<ThinkCoachOrder[]>>(
    THINK_API_URL + '/think/think-coach-order',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加教练组订单
 */
export async function addThinkCoachOrder(data: ThinkCoachOrder) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coach-order',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改教练组订单
 */
export async function updateThinkCoachOrder(data: ThinkCoachOrder) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coach-order',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除教练组订单
 */
export async function removeThinkCoachOrder(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coach-order/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除教练组订单
 */
export async function removeBatchThinkCoachOrder(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coach-order/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询教练组订单
 */
export async function getThinkCoachOrder(id: number) {
  const res = await request.get<ApiResult<ThinkCoachOrder>>(
    THINK_API_URL + '/think/think-coach-order/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
